/* Usage: java smallworld_degenerate_test <n> <dx> <dy> <seed> <output_file>
 * n is the number of friends, no less than 4.
 * dx and dy specify the line through the origin on which all friends lie.
 * seed is a 64-bit integer used to seed the random number generator.
 */
public class smallworld_degenerate_test {
  public static void main(String[] args) {
    int n = Integer.parseInt(args[0]);
    if (n < 4) {
      System.exit(1);
    }
    double dx = Double.parseDouble(args[1]);
    double dy = Double.parseDouble(args[2]);
    long seed = Long.parseLong(args[2]);
    java.util.Random r = new java.util.Random(seed);
    Spacer sp = new Spacer(args[4]);
    java.util.List<Double> coords = new java.util.ArrayList<Double>();
    for (int i = 0; i < n; i++) {
      long a = Double.doubleToRawLongBits(180 * Math.pow(0.5, 26));
      long b = Double.doubleToRawLongBits(180);
      long c;
      do {
        c = r.nextLong();
      } while (c < a || b <= c);
      coords.add(Double.longBitsToDouble(c));
    }
    java.util.Collections.sort(coords);
    for (int i = 0; i < n; i++) {
      double t = coords.get(i);
      sp.print(i + 1);
      sp.printSpace();
      sp.print(dx * t);
      sp.printSpace();
      sp.print(dy * t);
      sp.println();
    }
    sp.close((int)seed % 3);
  }
}
