/* Usage: java smallworld_test <n> <seed> <output_file>
 * n is the number of friends, no less than 4.
 * seed is a 64-bit integer used to seed the random number generator.
 */
public class smallworld_test {
  public static void main(String[] args) {
    int n = Integer.parseInt(args[0]);
    if (n < 4) {
      System.exit(1);
    }
    long seed = Long.parseLong(args[1]);
    java.util.Random r = new java.util.Random(seed);
    Spacer sp = new Spacer(args[2]);
    double[] x = new double[1 + n];
    double[] y = new double[1 + n];
    for (int i = 1; i <= n; i++) {
      int j = r.nextInt(i);
      double d = Math.pow(i, 2 * r.nextDouble());
      x[i] = x[j] + r.nextGaussian() / d;
      y[i] = y[j] + r.nextGaussian() / d;
      sp.print(i);
      sp.printSpace();
      sp.print(60 * x[i]);
      sp.printSpace();
      sp.print(60 * y[i]);
      sp.println();
    }
    sp.close((int)seed % 3);
  }
}
